# -*- coding: utf8 -*-

from logging import getLogger
from base import BaseHandler

log = getLogger('su.artix.queue')


class DummyHandler(BaseHandler):
    """
    Обработчик-заглушка сервиса очередей
    Тело сообщения для dummy содержит поведение для заглушки
    """

    def __init__(self, dao, stopThreadsFlag, lastFailsLock, lastFails):
        super(DummyHandler, self).__init__(dao, stopThreadsFlag, lastFailsLock, lastFails)
        self.messageType = "dummy"
        self.name = "DummyHandler"
        self.sendMessageCalls = 0

    def sendMessage(self, message):
        log.info(u'Обработка сообщения %s, %s' % (message.messageid, message.body))

        if self.send(message):
            log.info(u'Обработчик DummyHandler. Сообщение %s успешно отправлено' % message.messageid)
            self.deleteSentMessage(message)
            return True

        log.info(u'Обработчик DummyHandler. Ошибка отправки сообщения %s' % message.messageid)
        return False

    def send(self, message):
        log.info(u"Отправка сообщения %s" % message.messageid)
        self.sendMessageCalls = self.sendMessageCalls + 1

        if message.body == "DoNotSend":
            log.info(u"Сообщение %s не отправлено" % message.messageid)
            return False
        log.info(u"Сообщение %s отправлено" % message.messageid)
        return True
